<template>
  <ContentWrapper>
    <div class="content-heading">
      <div>
        {{permission.id == 0 ? 'Registrar nova permissão' : 'Atualizar permissão - '+permission.readable_name}}
        <ol class="breadcrumb breadcrumb px-0 pb-0">
          <li class="breadcrumb-item">
            <a href="/permissions" @click.prevent="$router.push({path:'/permissions'})">Permissões</a>
          </li>
          <li class="breadcrumb-item active">{{permission.id == 0 ? 'Registrar' : 'Atualizar'}}</li>
        </ol>
      </div>
    </div>
    <div class="card">
      <!-- <div class="card-header">
        <div
          class="card-title"
        >{{permission.id == 0 ? 'Registrar nova permissão' : 'Atualizar permissão - '+permission.name}}</div>
        <div class="text-sm"></div>
      </div>-->
      <div :class="'card-body'">
        <!-- CADASTRO PERMISSÃO -->
        <form
          :class="(process ? ' whirl duo':'')"
          @submit.prevent="validateBeforeSubmitPermission('permission')"
          data-vv-scope="permission"
        >
          <div class="card-body">
            <!-- NOME -->
            <div class="form-group row">
              <label class="col-md-2 col-form-label">Nome da permissão*</label>
              <div class="col-md-6">
                <input
                  v-model="permission.readable_name"
                  v-validate="'required'"
                  :class="{'form-control':true, 'is-invalid': errors.has('permission.readable_name')}"
                  type="text"
                  name="permission.readable_name"
                >
                <span
                  v-show="errors.has('permission.readable_name')"
                  class="invalid-feedback"
                >Informe o nome da permissão</span>
              </div>
            </div>

            <!-- PERMISSAO -->
            <div class="form-group row">
              <label class="col-md-2 col-form-label">Permissão*</label>
              <div class="col-md-6">
                <input
                  v-model="permission.name"
                  v-validate="'required'"
                  :class="{'form-control':true, 'is-invalid': errors.has('permission.name')}"
                  type="text"
                  name="permission.name"
                >
                <span
                  v-show="errors.has('permission.name')"
                  class="invalid-feedback"
                >Informe a permissão</span>
              </div>
            </div>
            <div style="color:red">* Campos requeridos</div>
          </div>
          <div class="text-right">
            <b-button
              class="mr-1 mb-1"
              type="submit"
              :variant="'success'"
            >{{(permission.id == 0 ? 'Registrar' : 'Atualizar')}}</b-button>
          </div>
        </form>
      </div>
    </div>
  </ContentWrapper>
</template>
<script>
import Datatable from "@/components/Tables/Datatable";
import Multiselect from "vue-multiselect";
import swal from "sweetalert2";

import Permission from "@/domain/permission/Permission";
import PermissionService from "@/domain/permission/PermissionService";

import NotificationProvider from "@/provider/NotificationProvider";

export default {
  name: "permission-form",
  components: {
    Datatable,
    Multiselect
  },
  created() {
    if (this.$route.params.id) {
      this.process = true;
      this.permissionService
        .get(this.$route.params.id)
        .then(response => {
          this.permission = response;
          this.process = false;
        })
        .catch(err => {
          console.log(JSON.stringify(err));
          this.notificationProvider.error(
            "Falha na comunicação",
            "Não foi possível buscar a permissão selecionada"
          );
        });
    }
  },
  data() {
    return {
      process: false,
      permissionService: new PermissionService(),
      permission: new Permission(),
      notificationProvider: new NotificationProvider(this.$notify)
    };
  },
  methods: {
    validateBeforeSubmitPermission(scope) {
      this.$validator.validateAll(scope).then(result => {
        if (result) {
          this.process = true;
          if (this.permission.id == 0) {
            // CADASTRANDO
            this.permissionService
              .create(this.permission)
              .then(response => {
                this.notificationProvider.success(
                  "REGISTRADO!",
                  this.permission.name + " registrada com sucesso"
                );
                this.$router.push({ path: "/permissions" });
              })
              .catch(err => {
                console.log(JSON.stringify(err));
                if (
                  err.response &&
                  err.response.data &&
                  err.response.data.exception &&
                  err.response.data.exception ==
                    "Prettus\\Validator\\Exceptions\\ValidatorException"
                ) {
                  // alguma validação deu errado
                  for (var key in err.response.data.message) {
                    this.notificationProvider.error(
                      "Verificar " + key,
                      err.response.data.message[key][0]
                    );
                  }
                } else {
                  console.log(JSON.stringify(err));
                  this.notificationProvider.error(
                    "Falha ao registrar",
                    "Houve uma falha ao registrar a permissão"
                  );
                }
                this.process = false;
              });
          } else {
            // EDITANDO
            this.permissionService
              .update(this.permission.id, this.permission)
              .then(response => {
                this.notificationProvider.success(
                  "ATUALIZADO!",
                  this.permission.readable_name + " atualizada com sucesso"
                );
                this.$router.push({ path: "/permissions" });
              })
              .catch(err => {
                console.log(JSON.stringify(err));
                if (
                  err.response &&
                  err.response.data &&
                  err.response.data.exception &&
                  err.response.data.exception ==
                    "Prettus\\Validator\\Exceptions\\ValidatorException"
                ) {
                  // alguma validação deu errado
                  for (var key in err.response.data.message) {
                    this.notificationProvider.error(
                      "Verificar " + key,
                      err.response.data.message[key][0]
                    );
                  }
                } else {
                  console.log(JSON.stringify(err));
                  this.notificationProvider.error(
                    "Falha ao registrar",
                    "Houve uma falha ao registrar a permissão"
                  );
                }
                this.process = false;
              });
          }
        }
      });
    }
  }
};
</script>